/*
 * inputplugin.h
 * Copyright 2005 Red Hat Inc., Durham, North Carolina.
 * All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Authors:
 *     Steve Grubb <sgrubb@redhat.com>
 */
#ifndef INPUTPLUGIN_H
#define INPUTPLUGIN_H
#include <string>
#include "activeobject.h"
#include "circularqueue.h"

/**
 * Class InputPlugin
 * This class is used to instantiate plugins that receive events. It has a Circular Queue to hold inbound events that are occuring faster than can be dispatched.
 */
class InputPlugin : public ActiveObject {
/**
 * Public stuff
 */
public:
	/**
	 * Fields
	 */
	/**
	 * 
	 */
	/**
	 * Constructors
	 */
	/**
	 * Empty Constructor
	 */
	InputPlugin ( ) { }
	/**
	 * Accessor Methods
	 */
	/**
	 * Operations
	 */
/**
 * Protected stuff
 */
protected:
	/**
	 * Fields
	 */
	/**
	 * 
	 */
	/**
	 * Constructors
	 */
	/**
	 * Accessor Methods
	 */
	/**
	 * Operations
	 */
/**
 * Private stuff
 */
private:
	/**
	 * Fields
	 */
	 CircularQueue* event_queue;
	/**
	 * 
	 */
	/**
	 * Constructors
	 */
	/**
	 * Accessor Methods
	 */
	/**
	 * 
	 */
	CircularQueue& get_event_queue ( );
		
	
	/**
	 * 
	 */
	void set_event_queue (CircularQueue & value );
		
	
	/**
	 * Operations
	 */
};
#endif //INPUTPLUGIN_H

