#include <unistd.h>
#include <iostream>
#include "fault.h"
#include "thread.h"

using namespace std;

class Mythread : public Thread {
public:
    Mythread() { t = time(NULL); }
    ~Mythread() {}

protected:
    time_t t;

    bool mainHandler(int& stat, void* userData) {
        if (userData) {
            cout << (const char*)userData << endl;
        }
        else {
            cout << "Mythread::threadMain" << endl;
        }
        if (time(NULL) - t > 5) {
            stat = 0;
            return false;
        }
        stat = -1;
        return true;
    }
};

int main(int ac, char** av) {
    Mythread th1;
    Mythread th2;

    try {
        th1.start(NULL, Thread::PRIO_HIGH);
        th2.start((void*)"param");
#if 1
        int rc = th1.wait(3);
        cout << "th1: rc = " << rc << endl;
        th2.cancel();
        cout << "th2: rc = " << th2.exitCode() << endl;
#else
        time_t t = time(NULL);
        while(!th1.finished() && time(NULL) - t < 3) {
            cout << "suspending thread" << endl;
            th1.suspend();
            cout << "suspended" << endl;
            usleep(500000);
            cout << "resuming thread" << endl;
            th1.resume();
            cout << "resumed" << endl;
            usleep(500000);
        }
        th1.cancel();
        cout << "rc = " << th1.exitCode() << endl;
        th2.cancel();
        cout << "rc = " << th2.exitCode() << endl;
#endif
    }
    catch (Fault& fault) {
        cerr << "Fault occurred: " << fault.message() << endl;
    }
}

